ModelMBean (Java SE 26 & JDK 26)
Description: declaration: module: java.management, package: javax.management.modelmbean, interface: ModelMBean
Keywords: javax.management.modelmbean.ModelMBean interface

# Interface ModelMBean

All Superinterfaces:
  `DynamicMBean, ModelMBeanNotificationBroadcaster, NotificationBroadcaster, PersistentMBean`

All Known Implementing Classes:
  `RequiredModelMBean`

public interface ModelMBean extends DynamicMBean, PersistentMBean, ModelMBeanNotificationBroadcaster
This interface must be implemented by the ModelMBeans. An implementation of this interface must be shipped with every JMX Agent.

Java resources wishing to be manageable instantiate the ModelMBean using the MBeanServer's createMBean method. The resource then sets the ModelMBeanInfo (with Descriptors) for the ModelMBean instance. The attributes and operations exposed via the ModelMBeanInfo for the ModelMBean are accessible from MBeans, connectors/adaptors like other MBeans. Through the ModelMBeanInfo Descriptors, values and methods in the managed application can be defined and mapped to attributes and operations of the ModelMBean. This mapping can be defined during development in an XML formatted file or dynamically and programmatically at runtime.

Every ModelMBean which is instantiated in the MBeanServer becomes manageable: its attributes and operations become remotely accessible through the connectors/adaptors connected to that MBeanServer. A Java object cannot be registered in the MBeanServer unless it is a JMX compliant MBean. By instantiating a ModelMBean, resources are guaranteed that the MBean is valid.

MBeanException and RuntimeOperationsException must be thrown on every public method. This allows for wrapping exceptions from distributed communications (RMI, EJB, etc.). These exceptions do not have to be thrown by the implementation except in the scenarios described in the specification and javadoc.

Since:
  1.5

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `setManagedResource(Object mr, String mr_type)`
  Sets the instance handle of the object against which to execute all methods in this ModelMBean management interface (MBeanInfo and Descriptors).
  `void`
  `setModelMBeanInfo(ModelMBeanInfo inModelMBeanInfo)`
  Initializes a ModelMBean object using ModelMBeanInfo passed in.

  ### Methods declared in interface DynamicMBean

  `getAttribute, getAttributes, getMBeanInfo, invoke, setAttribute, setAttributes`
  Modifier and Type
  Method
  Description
  `Object`
  `getAttribute(String attribute)`
  Obtain the value of a specific attribute of the Dynamic MBean.
  `AttributeList`
  `getAttributes(String[] attributes)`
  Get the values of several attributes of the Dynamic MBean.
  `MBeanInfo`
  `getMBeanInfo()`
  Provides the exposed attributes and actions of the Dynamic MBean using an MBeanInfo object.
  `Object`
  `invoke(String actionName, Object[] params, String[] signature)`
  Allows an action to be invoked on the Dynamic MBean.
  `void`
  `setAttribute(Attribute attribute)`
  Set the value of a specific attribute of the Dynamic MBean.
  `AttributeList`
  `setAttributes(AttributeList attributes)`
  Sets the values of several attributes of the Dynamic MBean.

  ### Methods declared in interface ModelMBeanNotificationBroadcaster

  `addAttributeChangeNotificationListener, removeAttributeChangeNotificationListener, sendAttributeChangeNotification, sendAttributeChangeNotification, sendNotification, sendNotification`
  Modifier and Type
  Method
  Description
  `void`
  `addAttributeChangeNotificationListener(NotificationListener listener, String attributeName, Object handback)`
  Registers an object which implements the NotificationListener interface as a listener.
  `void`
  `removeAttributeChangeNotificationListener(NotificationListener listener, String attributeName)`
  Removes a listener for attributeChangeNotifications from the RequiredModelMBean.
  `void`
  `sendAttributeChangeNotification(AttributeChangeNotification notification)`
  Sends an attributeChangeNotification which is passed in to the registered attributeChangeNotification listeners on the ModelMBean.
  `void`
  `sendAttributeChangeNotification(Attribute oldValue, Attribute newValue)`
  Sends an attributeChangeNotification which contains the old value and new value for the attribute to the registered AttributeChangeNotification listeners on the ModelMBean.
  `void`
  `sendNotification(String ntfyText)`
  Sends a Notification which contains the text string that is passed in to the registered Notification listeners on the ModelMBean.
  `void`
  `sendNotification(Notification ntfyObj)`
  Sends a Notification which is passed in to the registered Notification listeners on the ModelMBean as a jmx.modelmbean.generic notification.

  ### Methods declared in interface NotificationBroadcaster

  `addNotificationListener, getNotificationInfo, removeNotificationListener`
  Modifier and Type
  Method
  Description
  `void`
  `addNotificationListener(NotificationListener listener, NotificationFilter filter, Object handback)`
  Adds a listener to this MBean.
  `MBeanNotificationInfo[]`
  `getNotificationInfo()`
  Returns an array indicating, for each notification this MBean may send, the name of the Java class of the notification and the notification type.
  `void`
  `removeNotificationListener(NotificationListener listener)`
  Removes a listener from this MBean.

  ### Methods declared in interface PersistentMBean

  `load, store`
  Modifier and Type
  Method
  Description
  `void`
  `load()`
  Instantiates thisMBean instance with the data found for the MBean in the persistent store.
  `void`
  `store()`
  Captures the current state of this MBean instance and writes it out to the persistent store.

- ## Method Details

  - ### setModelMBeanInfo

    void setModelMBeanInfo(ModelMBeanInfo inModelMBeanInfo) throws MBeanException, RuntimeOperationsException
    Initializes a ModelMBean object using ModelMBeanInfo passed in. This method makes it possible to set a customized ModelMBeanInfo on the ModelMBean as long as it is not registered with the MBeanServer.
    Once the ModelMBean's ModelMBeanInfo (with Descriptors) are customized and set on the ModelMBean, the ModelMBean can be registered with the MBeanServer.

    If the ModelMBean is currently registered, this method throws a `RuntimeOperationsException` wrapping an `IllegalStateException`

    Parameters:
      `inModelMBeanInfo` - The ModelMBeanInfo object to be used by the ModelMBean.
    Throws:
      `MBeanException` - Wraps a distributed communication Exception.
      `RuntimeOperationsException` -
      - Wraps an `IllegalArgumentException` if the MBeanInfo passed in parameter is null.
      - Wraps an `IllegalStateException` if the ModelMBean is currently registered in the MBeanServer.

  - ### setManagedResource

    void setManagedResource(Object mr, String mr_type) throws MBeanException, RuntimeOperationsException, InstanceNotFoundException, InvalidTargetObjectTypeException
    Sets the instance handle of the object against which to execute all methods in this ModelMBean management interface (MBeanInfo and Descriptors).
    Parameters:
      `mr` - Object that is the managed resource
      `mr_type` - The type of reference for the managed resource. Can be: ObjectReference, Handle, IOR, EJBHandle, RMIReference. If the MBeanServer cannot process the mr_type passed in, an InvalidTargetTypeException will be thrown.
    Throws:
      `MBeanException` - The initializer of the object has thrown an exception.
      `RuntimeOperationsException` - Wraps an IllegalArgumentException: The managed resource type passed in parameter is null.
      `InstanceNotFoundException` - The managed resource object could not be found
      `InvalidTargetObjectTypeException` - The managed resource type cannot be processed by the ModelMBean or JMX Agent.